/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/explicit-function-return-type */
function* localmaxSum(arr: number[], first: number, last: number){
    const firstIndex = arr.findIndex(x=> x > 0);
    if(firstIndex < 0) return;
    let sum = 0;
    let blockSum = 0;
    for (let index = first; index <= last; index++) {
        const element = arr[index];
        blockSum += element;
        if(blockSum > 0){
            sum += blockSum;
            blockSum = 0;
        }
        else if(sum + blockSum < 0){
            yield sum;
            blockSum = 0;
            sum = 0;
        }
    }
    yield sum;
}
export function getMaximumlSumSubArray(arr:number[]): number{
    let maxsum = 0;
    for(const g of localmaxSum(arr,0,arr.length - 1)){
        if(maxsum < g){
            maxsum = g;
        }
    }
    if(maxsum === 0){
        return Math.max(...arr);
    }
    return maxsum;
}
export function subarrayMaxSolve(arr:number[]): number{
    return getMaximumlSumSubArray(arr);
}

type TestCase = [number[],number];

export const testcases:TestCase[]=[
    [[1,5,-9,4],6],
    [[9,4,4,0],17],
    [[1,-90,5],5],
    [[1,2,-50,6],6],
    [[1,2,-90,1,4],5],
    [[1,2,-90,1,1,1,1],4],
    [[1,-90,91],91],
    [[-1,-2,-4],-1],
    [[-1,3,6],9],
    [[5,-50,4,-1,3],6]
]

//if(import.meta.main){
//    for (const [arr,s] of testcases) {
//        console.log("predict: ",solve(arr)," actual: ", s);
//    }
//}