export function algorithmicTradeISolve(arr:number[]):number{
    const localMax = arr.map((v,i,ar)=>{
        return Math.max(...ar.slice(i)) - v;
    });
    //console.log(localMax)
    return Math.max(...localMax, 0);
}

//console.log(algorithmicTrade1Solve([130,188,29,178,176,54,157,177,151,184,105,22,185,165,151,80,58,25]))
//163


export function algorithmicTradeIISolve(arr:number[]):number{
    const memo: number[][] = (new Array(arr.length)).fill([])
        .map(_=>new Array(arr.length).fill(-1));
    const v = solve(arr,0,0);
    return v;
    function solve(arr:number[],i: number,sellChance: number):number{
        if(arr.length == i){
            return 0;
        }
        if(memo[i][sellChance] >= 0){
            return memo[i][sellChance];
        }
        const result = [];
        if(sellChance == 1){
            const sell = arr[i];
            result.push(sell + solve(arr,i+1,0));
        }
        else {
            const buy = arr[i];
            result.push(-buy + solve(arr,i+1, 1));
        }
        result.push(solve(arr,i+1,sellChance));
        
        const v = Math.max(...result);
        memo[i][sellChance] = v;
        return v;
    }
}
//console.log(algorithmicTrade2Solve([17,172,46,80,159,16,159,182,60,27,114,75,176,106,5,30,130,87,22]))
//747

export function algorithmicTradeIIISolve(arr:number[]):number{
    const memo: number[][] = (new Array(arr.length)).fill([])
        .map(_=>new Array(5).fill(-1));
    const v = solve(arr,0,4);
    console.log(memo)
    return v;
    function solve(arr:number[],i: number,transaction: number):number{
        if(arr.length == i){
            return 0;
        }
        if(transaction == 0){
            return 0;
        }
        if(memo[i][transaction] >= 0){
            return memo[i][transaction];
        }
        const result = [];
        const isBuy = transaction % 2 === 0;
        if(isBuy){
            const buy = arr[i];
            result.push(-buy + solve(arr,i+1, transaction - 1));
        }
        else {
            const sell = arr[i];
            result.push(sell + solve(arr,i+1, transaction - 1));
        }
        result.push(solve(arr,i+1,transaction));
        
        const v = Math.max(...result);
        memo[i][transaction] = v;
        return v;
    }
}

//console.log(algorithmicTradeIIISolve([25,166,22,187,140,184,118,71,36,43,127,68,94,133,141]))
//306

export function algorithmicTradeIVSolve([transaction,arr]:[number,number[]]):number{
    const memo: number[][] = (new Array(arr.length)).fill([])
        .map(_=>new Array(transaction * 2 + 4).fill(-1));
    const v = solve(arr,0,transaction * 2);
    console.log(memo)
    return v;
    function solve(arr:number[],i: number,transaction: number):number{
        if(arr.length == i){
            return 0;
        }
        if(transaction == 0){
            return 0;
        }
        if(memo[i][transaction - 1] >= 0){
            return memo[i][transaction - 1];
        }
        const result = [];
        const isBuy = transaction % 2 === 0;
        if(isBuy){
            const buy = arr[i];
            result.push(-buy + solve(arr,i+1, transaction - 1));
        }
        else {
            const sell = arr[i];
            result.push(sell + solve(arr,i+1, transaction - 1));
        }
        result.push(solve(arr,i+1,transaction));
        
        const v = Math.max(...result);
        memo[i][transaction - 1] = v;
        return v;
    }
}

//const v = algorithmicTradeIVSolve([7, [86,97,78,46,113,13,79,42,153,96,93,116,64,190,5,76,66,121,149,177,56,33,75,107,99,106,117]])
//console.log(v);
//649