//Minimum Path Sum in a Triangle

export function minimumTrianglePathSumSolve(triangle:number[][]):number{
    const minSum = [[triangle[0][0]]];
    for (let i = 1; i < triangle.length; i++) {
        const arr = triangle[i];
        const tmp = [];
        for (let j = 0; j < arr.length; j++) {
            const cur = triangle[i][j];
            if(j - 1 < 0){
                tmp.push(minSum[i-1][j]+ cur);
            }
            else if(j >= triangle[i-1].length){
                tmp.push(minSum[i-1][j-1] + cur);
            }
            else {
                tmp.push(Math.min(minSum[i-1][j-1],minSum[i-1][j])+ cur);
            }
        }
        minSum.push(tmp);
    }
    return Math.min(...minSum[minSum.length - 1]);
}

const case1 = [
    [2],
   [3,4],
  [6,5,7],
 [4,1,8,3]
];

const case2 = [
             [3],
            [8,5],
           [3,5,4],
          [2,6,3,4],
         [9,6,5,5,3],
        [6,1,6,5,2,4],
       [6,7,7,1,1,8,6],
      [7,6,5,9,3,9,2,2],
     [6,3,4,6,9,2,8,8,5],
    [1,4,6,3,6,5,5,1,9,2],
   [1,6,3,6,6,7,2,9,6,6,1],
  [1,3,9,8,3,7,1,7,4,5,6,6]
];
interface TestCase{
    data: number[][];
    ans: number;
}
export const testcases: TestCase[] = [
    {
        data:case1,
        ans:6,
    },
    {
        data:case2,
        ans:35
    }
];